{
  inputs = {
    nixpkgs.url = "github:nixos/nixpkgs/nixpkgs-unstable";
    cclyzerpp.url = "github:peperunas/cclyzerpp/flake";
    flake-utils.url = "github:numtide/flake-utils";
  };

  outputs = { self, nixpkgs, flake-utils, cclyzerpp }:
    flake-utils.lib.eachDefaultSystem (system:
      let
        pkgs = import nixpkgs {
          inherit system;
          config.allowUnfree = true;
        };

        shellWithPkgs = packages: pkgs.mkShell {
          inherit packages;
        };

        cclyzer = cclyzerpp.defaultPackage.${system};

        shell = with pkgs; shellWithPkgs [ codeql klee souffle cclyzer ];
      in
      {
        packages = rec {
          workbench = {
            files_handling = pkgs.callPackage ./workbench/files_handling/default.nix { cclyzerpp = cclyzer; };
          };
          
          default = workbench.files_handling;
        };
        devShell = shell;
      });
}


